// Documentation for Mermaid: https://github.com/mermaid-js/mermaid/blob/develop/docs/usage.md

var global_err = "";

// This imitates having a <script>-element with an external resource in the <head> segment. 
const script = document.createElement('script');
script.setAttribute('src', 'https://cdn.jsdelivr.net/npm/mermaid/dist/mermaid.min.js');
script.onload = function() {
	// Default font is: "trebuchet ms",verdana,arial,sans-serif
	//  It seems to be tricky to change in a reliable way

	mermaid.initialize({ startOnLoad: false/*, themeVariables: { "fontFamily": "sans-serif", "fontSize": 11 }*/ });
	mermaid.parseError = function(err, hash) {
		global_err = err;
	};

	window.webkit.messageHandlers.initializationMessageHandler.postMessage("");
};
// script.onerror = function() {};

document.head.appendChild(script);

// Function called by MailMate
window.mm_perform_action = function(input) {
	let res = "";
	try {
		// The dummy_id random value isn't strictly necessary since MailMate will also inline the stylesheet.
		res = mermaid.mermaidAPI.render(`svg_id_${Math.floor(Math.random() * 1000000)}`,input);
	} catch(error) {
		// The error.message value is often pretty useless here. We try to get something better.

		// The use of a global error value only works because JavaScript is single-threaded.
		global_err = "";
		mermaid.parse(input); // Needed globalThis on pre-macOS 11.0.
		if(global_err !== "") {
			// Throw extended version of original error
		    throw new Error(global_err, { cause: error });
		}

		// Rethrow original error
		throw error
	}
	return res;
}

true; // Needed on pre-macOS 11.0.
